﻿using System;
using System.Windows.Forms;
using AtmaHunter.Settings;
using System.Security.Cryptography;
using System.Text;

namespace AtmaHunter
{
    public partial class AtmaHunterForm : Form
    {
        private bool sPassChanged = false;
        private string sOldPass = "";
        public AtmaHunterForm()
        {
            InitializeComponent();
        }

        private void chkUseTimeMethod_CheckedChanged(object sender, EventArgs e)
        {
            
        }

        private void AtmaHunterForm_Load(object sender, EventArgs e)
        {

            chkUseTimeMethod.Checked = AtmaHunterSettings.instance.UseJSTTheory;
            chkSSL.Checked = AtmaHunterSettings.instance.SMTPUseSSL;
            txtServer.Text = AtmaHunterSettings.instance.SMTPServer;
            txtPort.Text = AtmaHunterSettings.instance.SMTPPort;
            txtSMS.Text = AtmaHunterSettings.instance.TextEmail;
            chkSendSMS.Checked = AtmaHunterSettings.instance.SendSMS;
            sOldPass = AtmaHunterSettings.instance.LoginPassword;

            if (chkSendSMS.Checked && AtmaHunterSettings.instance.LoginPassword != null && AtmaHunterSettings.instance.KeyString != null)
                txtPass.Text = AtmaHunterSettings.instance.LoginPassword;

            sOldPass = txtPass.Text;
            txtUName.Text = AtmaHunterSettings.instance.LoginName;
            txtFromEmail.Text = AtmaHunterSettings.instance.FromEmail;
            
        }

        private void chkSSL_CheckedChanged(object sender, EventArgs e)
        {
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            AtmaHunterSettings.instance.UseJSTTheory = chkUseTimeMethod.Checked;
            AtmaHunterSettings.instance.SMTPUseSSL = chkSSL.Checked;
            AtmaHunterSettings.instance.SMTPServer = txtServer.Text;
            AtmaHunterSettings.instance.SMTPPort = txtPort.Text;
            AtmaHunterSettings.instance.TextEmail = txtSMS.Text;
            AtmaHunterSettings.instance.LoginName = txtUName.Text;
            AtmaHunterSettings.instance.FromEmail = txtFromEmail.Text;
            AtmaHunterSettings.instance.SendSMS = chkSendSMS.Checked;
            AtmaHunterSettings.instance.SoundFile = txtSound.Text;
            AtmaHunterSettings.instance.PlaySound = chkSound.Checked;
            if (chkSendSMS.Checked)
            {
                if (sPassChanged)
                {
                    sPassChanged = false;

                    Reset frmReset = new Reset();
                    if (frmReset.ShowDialog() == DialogResult.Cancel)
                    {
                        txtPass.Text = AtmaHunterSettings.instance.LoginPassword;
                        frmReset.Dispose();
                        return;
                    }
                    else
                    {
                        AtmaHunterSettings.instance.KeyString = GenerateRandomKey(frmReset.sSecureKey);
                        AtmaHunterSettings.instance.LoginPassword = Encrypt(txtPass.Text, AtmaHunterSettings.instance.KeyString);
                    }

                    frmReset.Dispose();

                }

                this.Close();

            }

            

        }

        private string GenerateRandomKey(string RandomKey)
        {
            string sPhrase = RandomKey;
            string sSalt = RandomKey;
            string Algo = "SHA1";
            int passwordIt = 5;
            int keySize = 256;
            byte[] bytesSalt = Encoding.ASCII.GetBytes(sSalt);
            PasswordDeriveBytes pdb = new PasswordDeriveBytes(RandomKey, bytesSalt, Algo, passwordIt);
            byte[] Key = pdb.GetBytes(keySize / 11);
            String sKey = Convert.ToBase64String(Key);

            return sKey;
        }

        private static string Encrypt(string plainStr, string KeyString)
        {
            RijndaelManaged aesEncryption = new RijndaelManaged();
            aesEncryption.KeySize = 256;
            aesEncryption.BlockSize = 128;
            aesEncryption.Mode = CipherMode.ECB;
            aesEncryption.Padding = PaddingMode.ISO10126;
            byte[] KeyInBytes = Encoding.UTF8.GetBytes(KeyString);
            aesEncryption.Key = KeyInBytes;
            byte[] plainText = ASCIIEncoding.UTF8.GetBytes(plainStr);
            ICryptoTransform crypto = aesEncryption.CreateEncryptor();
            byte[] cipherText = crypto.TransformFinalBlock(plainText, 0, plainText.Length);
            return Convert.ToBase64String(cipherText);
        }

        private static string Decrypt(string encryptedText, string KeyString)
        {
            RijndaelManaged aesEncryption = new RijndaelManaged();
            aesEncryption.KeySize = 256;
            aesEncryption.BlockSize = 128;
            aesEncryption.Mode = CipherMode.ECB;
            aesEncryption.Padding = PaddingMode.ISO10126;
            byte[] KeyInBytes = Encoding.UTF8.GetBytes(KeyString);
            aesEncryption.Key = KeyInBytes;
            ICryptoTransform decrypto = aesEncryption.CreateDecryptor();
            byte[] encryptedBytes = Convert.FromBase64CharArray(encryptedText.ToCharArray(), 0, encryptedText.Length);
            return ASCIIEncoding.UTF8.GetString(decrypto.TransformFinalBlock(encryptedBytes, 0, encryptedBytes.Length));
        }

        private void txtPass_TextChanged(object sender, EventArgs e)
        {
            if (sOldPass != txtPass.Text)
                sPassChanged = true;
        }

        private void bBrowse_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFile = new OpenFileDialog();
            openFile.Filter = "Wave files (*.wav)|*.wav";
            if (openFile.ShowDialog() == DialogResult.Cancel)
                return;

            txtSound.Text = openFile.FileName;
        }

    }
}
